// ====================================================
//
// Copyright (c) 2002 Sean Wilson. All Rights Reserved.
//
// ====================================================

#include "exception.h"

namespace seanw
{
namespace exception
{

#ifdef _WIN32
win32Exception::win32Exception(unsigned int exceptionCode)
{
	switch (exceptionCode)
	{
		case EXCEPTION_ACCESS_VIOLATION:         message = "EXCEPTION_ACCESS_VIOLATION software exception.";         return;
		case EXCEPTION_ARRAY_BOUNDS_EXCEEDED:    message = "EXCEPTION_ARRAY_BOUNDS_EXCEEDED software exception.";    return;
		case EXCEPTION_BREAKPOINT:               message = "EXCEPTION_BREAKPOINT software exception.";               return;
		case EXCEPTION_DATATYPE_MISALIGNMENT:    message = "EXCEPTION_DATATYPE_MISALIGNMENT software exception.";    return;
		case EXCEPTION_FLT_DENORMAL_OPERAND:     message = "EXCEPTION_FLT_DENORMAL_OPERAND software exception.";     return;
		case EXCEPTION_FLT_DIVIDE_BY_ZERO:       message = "EXCEPTION_FLT_DIVIDE_BY_ZERO software exception.";       return;
		case EXCEPTION_FLT_INEXACT_RESULT:       message = "EXCEPTION_FLT_INEXACT_RESULT software exception.";       return;
		case EXCEPTION_FLT_INVALID_OPERATION:    message = "EXCEPTION_FLT_INVALID_OPERATION software exception.";    return;
		case EXCEPTION_FLT_OVERFLOW:             message = "EXCEPTION_FLT_OVERFLOW software exception.";             return;
		case EXCEPTION_FLT_STACK_CHECK:          message = "EXCEPTION_FLT_STACK_CHECK software exception.";          return;
		case EXCEPTION_FLT_UNDERFLOW:            message = "EXCEPTION_FLT_UNDERFLOW software exception.";            return;
		case EXCEPTION_ILLEGAL_INSTRUCTION:      message = "EXCEPTION_ILLEGAL_INSTRUCTION software exception.";      return;
		case EXCEPTION_IN_PAGE_ERROR:            message = "EXCEPTION_IN_PAGE_ERROR software exception.";            return;
		case EXCEPTION_INT_DIVIDE_BY_ZERO:       message = "EXCEPTION_INT_DIVIDE_BY_ZERO software exception.";       return;
		case EXCEPTION_INT_OVERFLOW:             message = "EXCEPTION_INT_OVERFLOW software exception.";             return;
		case EXCEPTION_INVALID_DISPOSITION:      message = "EXCEPTION_INVALID_DISPOSITION software exception.";      return;
		case EXCEPTION_NONCONTINUABLE_EXCEPTION: message = "EXCEPTION_NONCONTINUABLE_EXCEPTION software exception."; return;
		case EXCEPTION_PRIV_INSTRUCTION:         message = "EXCEPTION_PRIV_INSTRUCTION software exception.";         return;
		case EXCEPTION_SINGLE_STEP:              message = "EXCEPTION_SINGLE_STEP software exception.";              return;
		case EXCEPTION_STACK_OVERFLOW:           message = "EXCEPTION_STACK_OVERFLOW software exception.";           return;
		default:                                 message = "Unknown software exception.";                            return;
	}
}
#endif

#ifdef _WIN32
void softwareExceptionTranslator(unsigned int exceptionCode, EXCEPTION_POINTERS* /*exceptionRecord*/)
{
    throw win32Exception(exceptionCode);
}
#endif

int badAllocHandler(size_t /*allocationSize*/)
{
	throw std::bad_alloc("Out of memory.");
}

}
}