// ====================================================
//
// Copyright (c) 2002 Sean Wilson. All Rights Reserved.
//
// ====================================================

#include "misc.h"

namespace seanw
{
namespace misc
{

std::string getErrorString(const char* filename, int line, const char* message)
{
	std::ostringstream error;

	error << filename << " (line " << line << ")\n" << message;

	return error.str();
}

#ifdef _WIN32
void showFatalError(const char* errorMessage)
{
	std::ostringstream message;

	message << "A fatal error has occured. The application will quit after you press the OK button.\n\nError message:\n" << errorMessage;

	::MessageBox(0, message.str().c_str(), "Fatal error", MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);
}
#endif

#ifdef _WIN32
std::string getCurrentDirectory()
{
	const int CURRENT_DIRECTORY_BUFFER_SIZE = 1024;
	
	char currentPath[CURRENT_DIRECTORY_BUFFER_SIZE];
	::GetCurrentDirectory(sizeof(currentPath), currentPath);

	return currentPath;
}
#endif

}
}